#ifndef CERTIFICATE_RETRIEVAL_IMPL_HPP
#define CERTIFICATE_RETRIEVAL_IMPL_HPP

#include <string>
#include <vector>
#include <map>

using std::string;
using std::vector;
using std::map;

namespace Akenti {

class AkentiCertificate;
class Certificate;
class URL;

/**
  * Class used to retrieve certificate and Akenti certificate
  *
  * @see URL
  * 
  * @version 1.1 00/05/01
  * @author Srilekha Mudumbai
  * @author Abdelilah Essiari
  */
class CertificateRetrievalImpl {

public:

  /**
    */
  virtual ~CertificateRetrievalImpl();

  /**
    */
  void
  getCertificates(const URL& url, 
                  map<string, string>& args,
                  vector<Certificate>& certs) const;

  /**
    */
  void
  getAkentiCertificates(const URL& url, 
                        map<string, string>& args,
                        vector<AkentiCertificate>& certs) const;

protected:

  /**
    */
  CertificateRetrievalImpl();

  /**
    */
  virtual void
  getContent(const URL& url, 
             map<string, string>& args,
             vector<string>& results,
             string &enc) const  = 0;

};

} // end of name space

#endif
