#ifndef DUMMY_CERTIFICATE_HPP
#define DUMMY_CERTIFICATE_HPP

#include "DummyCertificateImpl.hpp"
#include "AkentiCertificate.hpp"

namespace Akenti {

/**
  * The <i>DummyCertificate</i> is used in <i>CertInfo</i> objects 
  * that must exist to hold catastrophic error messages that occur 
  * before any certificates are collected (e.g. Root policy certificate
  * doesnt exist or has an irrecoverable error).
  *
  * @see AkentiCertificate
  * @see DummyCertificateImpl
  *
  * @version 1.0 04/05/20
  * @author Sushila R.Subramanian 
  **/

class DummyCertificate : public AkentiCertificate {

public:

  /** 
    */

  DummyCertificate() {
  }

  /** 
    */

  const DummyCertificateImpl* operator->() const {
    return (const DummyCertificateImpl*) get();
  }
  
private:

  typedef DummyCertificateImpl* ImplType;

};

} // end of namespace Akenti

#endif
