#ifndef AK_KEY_STORE_IMPL_HPP
#define AK_KEY_STORE_IMPL_HPP 

#include <string>
#include <vector>
#include "PrivateKey.hpp" 
#include "Certificate.hpp" 

using std::string;
using std::vector;

namespace Akenti {

/**
  *
  * @version 1.1
  * @author Srilekha Mudumbai
  * @author Abdelilah Essiari
  */
class KeyStoreImpl {

public:

  /**
    * Deletes this object.
    */
  virtual ~KeyStoreImpl() {
  }
 
  /**
    */
  const string& getType() {
    return type;
  }

  /**
    */
  const PrivateKey& getPrivateKey() const {
    return privateKey;
  }

  /**
    *
    */
  const Certificate& getSubjectCertificate() const {
    return subjectCert;
  }

  /**
    */
  const vector<Certificate>& getCaCertificates() const {
    return caCerts;
  }

  /**
    */
  virtual void load(const string& fileName, const string& password) = 0;

protected:

  /**
    * Constructs this object.
    */
  KeyStoreImpl(const string& type_arg) {
    this->type = type_arg;
  }
  
  string type;

  PrivateKey privateKey;

  Certificate subjectCert;
  
  vector<Certificate> caCerts;

};

} // end of namespace Akenti

#endif
