#ifndef POLICY_CERT_GENERATOR_IMPL_HPP
#define POLICY_CERT_GENERATOR_IMPL_HPP

#include <vector>
#include "AkentiCertGenerator.hpp"
#include "PolicyCertificateImpl.hpp"

using std::vector;

namespace Akenti {

class PolicyCertificateImpl;
class UseCondIssuerGroup;
class CertificateAuthorityInfo;
class Directory;

/**
  * <i>PolicyCertGenerator</i>
  *
  * @see AkentiCertGenerator
  * @see PolicyCertificateImpl
  *
  * @version 1.1 00/05/25
  * @author Srilekha Mudumbai
  * @author Abdelilah Essiari 
  **/

class PolicyCertGenerator : public AkentiCertGenerator {

public:

  /**
    */
  PolicyCertGenerator();

  /**
    */
  ~PolicyCertGenerator();
  
  /**
    */
  void 
  setResource(const string& resource);

  /**
    */
  void
  setCertificateAuthorityInfos(const vector<CertificateAuthorityInfo>& caInfos);

  /**
    */
  void 
  setIdentityDirectories(const vector<Directory>& idDirs);

  /**
    */
  void 
  setUseCondIssuerGroups(const vector<UseCondIssuerGroup>& useCondIssuerGroups);

  /**
    */
  void 
  setAttributeDirectories(const vector<Directory>& dirs);

  /**
    **/
  void 
  setCacheTime(long cacheTime);

protected:

  /**
    */ 
  PolicyCertGenerator(PolicyCertificateImpl* impl);

};

} // end of name space

#endif
