#ifndef AK_SECURITY_CONSTANTS_HPP
#define AK_SECURITY_CONSTANTS_HPP

namespace Akenti {

/**
  * A structure to define constants used by the security provider. Currently 
  * only values used by OpenSSL are defined since that is the only provider 
  * we have.
  */

struct SecurityConstants {

  /**
    * Message Digest Algorithms.
    */
  static const char* const MD5;

  /**
    */
  static const char* const MD2;

  /**
    */
  static const char* const SHA;

  static const char* const SHA1;

  /**
    * Signature Algorithms.
    */
  static const char* const RSA_MD5;     

  /**
    */
  static const char* const RSA_SHA;

  /**
    */
  static const char* const RSA_SHA1;

  /**
    */
  static const char* const DSA_SHA;

  /**
    */
  static const char* const DSA_SHA1;

  /**
    * Encodings for X509 certs and private keys.
    */
  static const char* const PEM;

  /**
    */
  static const char* const DER;

  /**
    * KeyTypes.
    */
  static const char* const RSA;

  /**
    */
  static const char* const DSA;

  /**
    */
  static const char* const DH;
    
private:

  SecurityConstants();

};

} // end of name space 
#endif

